"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncItersMergeSort = void 0;
var lodash_1 = require("lodash");
/**
 * Merge multiple async iterables into one, sorting the items order
 * according to provided criterion.
 *
 * It is assumed, that all input iterables are already sorted by this
 * sorting criterion.
 */
function asyncItersMergeSort(asyncIters, compareFunction) {
    if (compareFunction === void 0) { compareFunction = function (x) { return 0; }; }
    var readers = asyncIters.map(function (iter) {
        return ({
            iter: iter,
            // Refill the slot with next value from underlying iterable
            // whenever the slot is empty
            fill: function () {
                return __awaiter(this, void 0, void 0, function () {
                    var iterResult;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(!this.done && this.current === undefined)) return [3 /*break*/, 2];
                                return [4 /*yield*/, this.iter.next()];
                            case 1:
                                iterResult = _a.sent();
                                this.current = iterResult.value;
                                this.done = iterResult.done;
                                _a.label = 2;
                            case 2: return [2 /*return*/, this.done ? undefined : this];
                        }
                    });
                });
            },
        });
    });
    return (function () {
        return __asyncGenerator(this, arguments, function () {
            var compareReader, minReader;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!true) return [3 /*break*/, 9];
                        return [4 /*yield*/, __await(Promise.all(readers.map(function (reader) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/, reader.fill()];
                            }); }); })))];
                    case 1:
                        // update readers and get rid of finished ones
                        readers = (_a.sent()).filter(function (reader) {
                            return reader !== undefined && !reader.done;
                        });
                        if (!(readers.length === 0)) return [3 /*break*/, 3];
                        return [4 /*yield*/, __await(void 0)];
                    case 2: 
                    // stop the generator
                    return [2 /*return*/, _a.sent()];
                    case 3:
                        compareReader = function (reader) {
                            return (reader === null || reader === void 0 ? void 0 : reader.current) === undefined ? 0 : compareFunction(reader.current);
                        };
                        minReader = lodash_1.minBy(readers, compareReader);
                        if (!(minReader !== undefined && minReader.current !== undefined)) return [3 /*break*/, 6];
                        return [4 /*yield*/, __await(minReader.current)];
                    case 4: 
                    // give out current value from this reader
                    return [4 /*yield*/, _a.sent()];
                    case 5:
                        // give out current value from this reader
                        _a.sent();
                        // free up its slot for the next value
                        minReader.current = undefined;
                        return [3 /*break*/, 8];
                    case 6: return [4 /*yield*/, __await(void 0)];
                    case 7: 
                    // just in case: stop the generator on fail to get a value
                    return [2 /*return*/, _a.sent()];
                    case 8: return [3 /*break*/, 0];
                    case 9: return [2 /*return*/];
                }
            });
        });
    })();
}
exports.asyncItersMergeSort = asyncItersMergeSort;
//# sourceMappingURL=index.js.map